/*
 * touch.c
 *
 *  Created on: 29.05.2009
 *      Author: sebastian
 */

#include "touch.h"


/**
 * This functions set 5V to X1 and GND to Y1,
 * the voltage at X2 is measured via the ADC.
 * If the ADC-Value is less then TOUCH_PRESSED_LEVEL,
 * the function will return 1.
 * \return 1 if pressed else 0
 */
inline uint8_t touch_is_pressed(void) 
{
	return (readADC(TOUCH_X2) < TOUCH_PRESSED_LEVEL);
}

/**
 *
 *
 */
int16_t x_offset = 0;
int16_t x_mul = 1;
int16_t x_div = 1;

int16_t touch_readX(void) 
{
	int16_t pos = -1;

	if(touch_is_pressed()) 
	{
		pos = ((readADC(TOUCH_Y1) - x_offset) * x_mul + x_div/2) / x_div;
	}
	return pos;
}

int16_t y_offset = 0;
int16_t y_mul = 1;
int16_t y_div = 1;

int16_t touch_readY(void) 
{
	int16_t pos = -1;

	if(touch_is_pressed()) 
	{
		pos = ((readADC(TOUCH_X1) - y_offset) * y_mul + y_div/2) / y_div;
	}
	return pos;
}

void touch_debounce_off(void)
{
        do {
	    while(touch_is_pressed())
		_delay_ms(50);
    	    _delay_ms(50);
	} while(touch_is_pressed());
}

void touch_debounce_on(void)
{
        do {
	    while(!touch_is_pressed())
		_delay_ms(50);
    	    _delay_ms(50);
	} while(!touch_is_pressed());
}

